=== debian/changelog ===
fuzzylite (5.0+dfsg-3) unstable; urgency=medium

  * change my email in Uploaders field to josch@debian.org
  * add Vcs-Browser and Vcs-Git fields
  * d/watch: use repacksuffix and use dversionmangle instead of uversionmangle
  * d/rules: add get-orig-source target
  * change priority from extra to optional because it has no conflicts and is
    not a debug package

 -- Johannes Schauer <josch@debian.org>  Wed, 04 Feb 2015 14:14:39 +0100

fuzzylite (5.0+dfsg-2) unstable; urgency=medium

  * add patch 20141027-fix-some-spelling to fix some spelling mistakes until
    the next upstream release
  * bump Standards-Version to 3.9.6. No changes needed.

 -- Johannes Schauer <j.schauer@email.de>  Sun, 16 Nov 2014 22:14:30 +0100

fuzzylite (5.0+dfsg-1) unstable; urgency=low

  * Initial release. (Closes: #761075)

 -- Johannes Schauer <j.schauer@email.de>  Mon, 01 Sep 2014 21:25:35 +0200
