=== debian/control ===
Source: fuzzylite
Section: misc
Priority: optional
Maintainer: Johannes Schauer <josch@debian.org>
Standards-Version: 3.9.6
Homepage: http://www.fuzzylite.com/cpp/
Build-Depends: debhelper (>= 9), cmake
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/fuzzylite.git/
Vcs-Git: git://anonscm.debian.org/collab-maint/fuzzylite.git

Package: fuzzylite
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: fuzzy logic control binary
 fuzzylite is a fuzzy logic control library which allows one to easily
 create fuzzy logic controllers in a few steps utilizing object-oriented
 programming. It supports five controller types (Mamdani, Takagi-Sugeno,
 Larsen, Tsukamoto, Inverse Tsukamoto), 20 linguistic terms, five
 integral and two weighted defuzzifiers, six hedge types, three import
 types (FuzzyLite Language, Fuzzy Inference System and Fuzzy Control
 Language) and six export types (C++, Java, FuzzyLite Language, FuzzyLite
 Dataset, Fuzzy Inference System, Fuzzy Control Language). It comes
 bundled with more than thirty examples for Mamdani, Takagi-Sugeno and
 Tsukamoto controllers from fuzzylite, octave and matlab, each in all
 supported export formats.
 .
 This package contains the runtime binary


Package: libfuzzylite5.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: fuzzy logic control shared library
 fuzzylite is a fuzzy logic control library which allows one to easily
 create fuzzy logic controllers in a few steps utilizing object-oriented
 programming. It supports five controller types (Mamdani, Takagi-Sugeno,
 Larsen, Tsukamoto, Inverse Tsukamoto), 20 linguistic terms, five
 integral and two weighted defuzzifiers, six hedge types, three import
 types (FuzzyLite Language, Fuzzy Inference System and Fuzzy Control
 Language) and six export types (C++, Java, FuzzyLite Language, FuzzyLite
 Dataset, Fuzzy Inference System, Fuzzy Control Language). It comes
 bundled with more than thirty examples for Mamdani, Takagi-Sugeno and
 Tsukamoto controllers from fuzzylite, octave and matlab, each in all
 supported export formats.
 .
 This package contains the shared library

Package: libfuzzylite-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libfuzzylite5.0 (= ${binary:Version})
Section: libdevel
Description: fuzzy logic control development headers
 fuzzylite is a fuzzy logic control library which allows one to easily
 create fuzzy logic controllers in a few steps utilizing object-oriented
 programming. It supports five controller types (Mamdani, Takagi-Sugeno,
 Larsen, Tsukamoto, Inverse Tsukamoto), 20 linguistic terms, five
 integral and two weighted defuzzifiers, six hedge types, three import
 types (FuzzyLite Language, Fuzzy Inference System and Fuzzy Control
 Language) and six export types (C++, Java, FuzzyLite Language, FuzzyLite
 Dataset, Fuzzy Inference System, Fuzzy Control Language). It comes
 bundled with more than thirty examples for Mamdani, Takagi-Sugeno and
 Tsukamoto controllers from fuzzylite, octave and matlab, each in all
 supported export formats.
 .
 This package contains the development headers
