## fuzzylite 5.1%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: fuzzylite
 Section: misc
 Priority: optional
-Maintainer: Johannes Schauer <josch@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Johannes Schauer <josch@debian.org>
 Standards-Version: 3.9.6
 Homepage: http://www.fuzzylite.com/cpp/
 Build-Depends: debhelper (>= 9), cmake
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/fuzzylite.git/
-Vcs-Git: git://anonscm.debian.org/collab-maint/fuzzylite.git
+Vcs-Browser: https://browse.dgit.debian.org/fuzzylite.git/
+Vcs-Git: https://git.dgit.debian.org/fuzzylite
 
 Package: fuzzylite
 Architecture: any
@@ -27,11 +28,14 @@
  This package contains the runtime binary
 
 
-Package: libfuzzylite5.0
+Package: libfuzzylite5.1v5
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
+Replaces: libfuzzylite5.1
+Breaks: libfuzzylite5.1
+Conflicts: libfuzzylite5.1
 Description: fuzzy logic control shared library
  fuzzylite is a fuzzy logic control library which allows one to easily
  create fuzzy logic controllers in a few steps utilizing object-oriented
@@ -50,7 +54,7 @@
 Package: libfuzzylite-dev
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libfuzzylite5.0 (= ${binary:Version})
+Depends: ${misc:Depends}, libfuzzylite5.1v5 (= ${binary:Version})
 Section: libdevel
 Description: fuzzy logic control development headers
  fuzzylite is a fuzzy logic control library which allows one to easily
