=== debian/changelog ===
fuzzylite (5.1+dfsg-5) unstable; urgency=medium

  * update symbols file using "pkgkde-symbolshelper batchpatch -v '5.1' *.log"
    and build logs for all architectures acquired via "getbuildlog fuzzylite
    '5.1\+dfsg-4'"

 -- Johannes Schauer <josch@debian.org>  Wed, 23 Nov 2016 22:48:59 +0000

fuzzylite (5.1+dfsg-4) unstable; urgency=medium

  * bump Standards-Version to 3.9.8 (no changes required)
  * start using pkgkde-symbolshelper
  * bump debhelper compat level to 10
  * d/rules: export DEB_BUILD_MAINT_OPTIONS = hardening=+all

 -- Johannes Schauer <josch@debian.org>  Wed, 23 Nov 2016 17:55:13 +0000

fuzzylite (5.1+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload, with maintainer permission

  [ Steve Langasek ]
  * Fix up symbols file for symbols that are not part of the ABI and are
    optimized away at -O3 (Closes: #819142).

  [ Gianfranco Costamagna ]
  * Fix build failure with gcc-6 with upstream help (Closes: #811880)
  * Update symbols.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 13 Aug 2016 15:33:03 +0200

fuzzylite (5.1+dfsg-3) unstable; urgency=medium

  * let libfuzzylite5.1v5 replace libfuzzylite5.1 (Closes: #803357)
  * add debian/libfuzzylite5.1v5.symbols.optional to deal with all the
    libstdc++6/cxx11 junk symbols on 32 as well as on 64 bit arches

 -- Johannes Schauer <josch@debian.org>  Sun, 01 Nov 2015 10:34:42 +0100

fuzzylite (5.1+dfsg-2) unstable; urgency=medium

  * start using dgit git repositories and change Vcs-Browser and Vcs-Git
    field.
  * replace package libfuzzylite5.1 by libfuzzylite5.1v5 because of libstdc++6
    ABI changes (closes: #799818)

 -- Johannes Schauer <josch@debian.org>  Sun, 25 Oct 2015 22:27:15 +0100

fuzzylite (5.1+dfsg-1) unstable; urgency=medium

  * new upstream version (Closes: #777858)
  * removed debian/patches/20140705-minor-improvements-on-building-script as
    upstream integrated it. Adjust build options in d/rules accordingly.
  * delete debian/patches/20140714-building-from-objects-just-once and
    debian/patches/20141027-fix-some-spelling as they have been applied
    upstream
  * install usr/lib/*/pkgconfig/fuzzylite.pc in fuzzylite-dev
  * SONAME bump from 5.0 to 5.1, so renaming libfuzzylite5.0 to
    libfuzzylite5.1
  * add debian/patches/pkgconfig_installdir to install pkgconfig file in
    correct location

 -- Johannes Schauer <josch@debian.org>  Tue, 07 Jul 2015 11:12:00 +0200
