=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: fuzzylite
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Johannes Schauer <josch@debian.org>
-Standards-Version: 3.9.6
+Maintainer: Johannes Schauer <josch@debian.org>
+Standards-Version: 3.9.8
 Homepage: http://www.fuzzylite.com/cpp/
-Build-Depends: debhelper (>= 9), cmake
+Build-Depends: debhelper (>= 10), cmake, pkg-kde-tools
 Vcs-Browser: https://browse.dgit.debian.org/fuzzylite.git/
 Vcs-Git: https://git.dgit.debian.org/fuzzylite
