## fuzzylite 6.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: fuzzylite
 Section: misc
 Priority: optional
-Maintainer: Johannes Schauer <josch@debian.org>
-Standards-Version: 3.9.8
-Homepage: http://www.fuzzylite.com/cpp/
-Build-Depends: debhelper (>= 10), cmake, pkg-kde-tools
-Vcs-Browser: https://browse.dgit.debian.org/fuzzylite.git/
-Vcs-Git: https://git.dgit.debian.org/fuzzylite
+Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
+Standards-Version: 4.6.1
+Homepage: https://www.fuzzylite.com/cpp/
+Build-Depends: debhelper-compat (= 13), cmake, catch2
+Vcs-Browser: https://salsa.debian.org/debian/fuzzylite
+Vcs-Git: https://salsa.debian.org/debian/fuzzylite.git
+Rules-Requires-Root: no
 
 Package: fuzzylite
 Architecture: any
@@ -27,14 +28,12 @@
  This package contains the runtime binary
 
 
-Package: libfuzzylite5.1v5
+Package: libfuzzylite6.0
 Architecture: any
 Multi-Arch: same
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Replaces: libfuzzylite5.1
-Breaks: libfuzzylite5.1
-Conflicts: libfuzzylite5.1
 Description: fuzzy logic control shared library
  fuzzylite is a fuzzy logic control library which allows one to easily
  create fuzzy logic controllers in a few steps utilizing object-oriented
@@ -53,7 +52,7 @@
 Package: libfuzzylite-dev
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libfuzzylite5.1v5 (= ${binary:Version})
+Depends: ${misc:Depends}, libfuzzylite6.0 (= ${binary:Version})
 Section: libdevel
 Description: fuzzy logic control development headers
  fuzzylite is a fuzzy logic control library which allows one to easily
