=== debian/changelog ===
fuzzylite (6.0+dfsg-9) unstable; urgency=medium

  * bump cmake_minimum_required for CMake 4.0 (Closes: #1112939)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 25 Sep 2025 09:24:28 +0200

fuzzylite (6.0+dfsg-8) unstable; urgency=medium

  * debian/patches/catch2v3: #include <random> (Closes: #1084257)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 07 Oct 2024 12:46:48 +0200

fuzzylite (6.0+dfsg-7) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Johannes Schauer Marin Rodrigues ]
  * add patch for catch2 v3 (closes: #1054682)
  * debian/rules: build with FL_BUILD_TESTS=OFF with DEB_BUILD_OPTIONS=nocheck

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sat, 28 Oct 2023 08:25:04 +0200

fuzzylite (6.0+dfsg-6) unstable; urgency=medium

  * debian/patches/reproducible.patch: add authorship information
  * debian/patches/fix-tests2.patch: update author email

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 12 Sep 2022 13:21:12 +0200

fuzzylite (6.0+dfsg-5) unstable; urgency=medium

  * debian/rules: set -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON to make the build
    reproducible
  * add patch to replace Catch with Catch2 (Closes: #1017155)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 12 Sep 2022 10:23:13 +0200

fuzzylite (6.0+dfsg-4) unstable; urgency=medium

  * add patch from https://github.com/fuzzylite/fuzzylite/pull/108 to support
    building with gcc-12 (closes: #1012933)
  * debian/salsa-ci.yml: enable SALSA_CI_REPROTEST_ENABLE_DIFFOSCOPE
  * debian/rules: disable LTO as it makes the testsuite fail
  * debian/{control,copyright}: fix my name

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 17 Jun 2022 10:57:37 +0200

fuzzylite (6.0+dfsg-3) unstable; urgency=medium

  * add debian/salsa-ci.yml
  * add debian/gbp.conf
  * debian/rules: remove get-orig-source target
  * debian/libfuzzylite6.0.lintian-overrides: update for new library version
    and lintian tag name
  * remove debian/compat in favor of debhelper-compat (= 13)
  * debian/control: update Vcs-Browser and Vcs-Git for salsa
  * debian/rules: remove dh_install --fail-missing (it's the default now)
  * debian/control: add Rules-Requires-Root: no
  * debian/control: bump Standards-Version to 4.5.0 (no changes required)
  * add patch to make reproducible
  * debian/rules: build with reproducible=+fixfilepath (closes: #972303)

 -- Johannes 'josch' Schauer <josch@debian.org>  Tue, 27 Oct 2020 09:28:00 +0100

fuzzylite (6.0+dfsg-2) unstable; urgency=medium

  * instead of symlinking the examples directory, change the build directory
  * set DPKG_EXPORT_BUILDFLAGS=1 for hardening
  * add patch to fix unit test on i386

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 03 Feb 2019 10:43:13 +0100

fuzzylite (6.0+dfsg-1) unstable; urgency=medium

  * new upstream version
  * install examples in fuzzylite package
  * SONAME change: replace libfuzzylite5.1v5 with libfuzzylite6.0
  * put libfuzzylite6.0 in section libs
  * disable pkgkde-symbolshelper: too little gain for all the work
  * use secure copyright-format-uri

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 27 Jan 2019 15:49:39 +0100
