=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath optimize=-lto
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# for DEB_HOST_GNU_TYPE and DEB_HOST_MULTIARCH
include /usr/share/dpkg/architecture.mk

# we build in a subdirectory of ./fuzzylite because the unit tests expect the
# ./examples directory to be two levels above, see
# https://github.com/fuzzylite/fuzzylite/issues/85
%:
	dh $@ --sourcedirectory=fuzzylite --builddirectory=fuzzylite/obj-$(DEB_HOST_GNU_TYPE)

CONFOPTS += -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)
CONFOPTS += -DCMAKE_VERBOSE_MAKEFILE=true
CONFOPTS += -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	CONFOPTS += -DFL_BUILD_TESTS=OFF
else
	CONFOPTS += -DFL_BUILD_TESTS=ON
endif
override_dh_auto_configure:
	dh_auto_configure -- $(CONFOPTS)
