=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg$//" \
 https://github.com/fuzzylite/fuzzylite/releases .*/v(\d[\d\.]*)\.tar\.gz
